/* GCC */
#include <iostream>
#include <vector>
#include <queue>
#include <cstdio>
#include <algorithm>
int lcd(int x, int y){
    while (x!=0 && y!=0)
        if (x>y) x=x%y;
        else y=y%x;
    if (x==0) return(y);
    else return(x);
}
using namespace std;
int main(){
    freopen("resistor.in", "r", stdin);
    freopen("resistor.out", "w", stdout);
    int n,m; int ans1, ans2;
    scanf("%d %d", &n, &m);
    vector < vector < int > > g(m);
    vector < vector < int > > v(n);
    int a,b,c,d;
    for (int i=0; i<m; i++){
        scanf("%d %d %d %d", &a, &b, &c, &d);
        g[i].push_back(a);
        g[i].push_back(b);
        g[i].push_back(c);
        g[i].push_back(d);
        v[a-1].push_back(b-1);
        v[b-1].push_back(a-1);
    }

    vector < bool > used(n,0);
    used[0]=1;

    queue < int > q1;
    q1.push(0);
    while (q1.size()>0 && !used[n-1]){
        for (int i=0; i<v[q1.front()].size(); i++)
        if (!used[v[q1.front()][i]]){
            used[v[q1.front()][i]]=1;
            q1.push(v[q1.front()][i]);
        }
        q1.pop();
    }

    if (!used[n-1]) printf("Zero conductivity\n");
    else{

    sort(g.begin(), g.end());


    int k=0; int q; int l; int k1,k2;
    vector < vector < int > > r;
    while (k<m){
        q=k;
        while ((k<m-1) && (g[k][0]==g[k+1][0]) && (g[k][1]==g[k+1][1])) k++;
        r.resize(r.size()+1);
        r[r.size()-1].push_back(g[q][0]);
        r[r.size()-1].push_back(g[q][1]);
        ans1=g[q][3]; ans2=g[q][2];
        for (int i=q+1; i<=k; i++){
            l=lcd(ans1*g[i][2]+ans2*g[i][3], ans2*g[i][2]);
            k1=(ans1*g[i][2]+ans2*g[i][3])/l;
            k2=(ans2*g[i][2])/l;
            ans1=k1;
            ans2=k2;
        }
        r[r.size()-1].push_back(ans2);
        r[r.size()-1].push_back(ans1);
        k++;
    }


    ans1=r[0][2]; ans2=r[0][3];
    for (int i=1; i<r.size(); i++){
        l=lcd(r[i][2]*ans2+r[i][3]*ans1, r[i][3]*ans2);
            k1=(r[i][2]*ans2+r[i][3]*ans1)/l;
            k2=(r[i][3]*ans2)/l;
            ans1=k1;
            ans2=k2;
    }

    if (ans2!=1) printf("%d/%d\n", ans1, ans2);
    else printf("%d\n", ans1);
    }

    fclose(stdin);
    fclose(stdout);
}
