/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, m, i, j, l, a[110][110], b[110][110], c[110][110];
vector <int> otv;

int main()
{
    freopen("profit.in", "r", stdin);
    freopen("profit.out", "w", stdout);

    scanf("%d %d", &m, &n);
    for(i = 1; i <= m; i++)
        for(j = 1; j <= n; j++)
            scanf("%d", &a[i][j]);

    for(j = 0; j <= n; j++)
        a[0][j] = b[0][j] = c[0][j] = 0;

    for(i = 1; i <= m; i++)
    {
        b[i][1] = a[i][1];
        c[i][1] = i;
    }

    for(i = 1; i <= m; i++)
        for(j = 1; j < n; j++)
        {
            b[i][j + 1] = 0;
            for(l = 0; l <= i; l++)
                if(b[i][j + 1] < b[i - l][j] + a[l][j + 1])
                {
                    b[i][j + 1] = b[i - l][j] + a[l][j + 1];
                    c[i][j + 1] = l;
                }
        }

    otv.clear();
    i = m;
    j = n;
    while(j > 0)
    {
        otv.push_back(c[i][j]);
        i = i - c[i][j];
        j--;
    }

    printf("%d\n", b[m][n]);
    for(j = otv.size() - 1; j > 0; j--)
        printf("%d ", otv[j]);
    printf("%d\n", otv[j]);

    return 0;
}







