/* GCC */
#include <fstream>
#include <vector>

using namespace std;

int main()
{
    size_t m, n, cur_variant;
    ifstream in("profit.in");
    in >> m >> n;
    vector<vector<size_t> > p(n+1, vector<size_t>(m+1));
    vector<vector<pair<size_t, size_t> > > dp(n+1, vector<pair<size_t, size_t> >(m+1));
    vector<size_t> ans;
    ans.reserve(n);
    for(size_t i = 1; i <= m; ++i)
        for(size_t j = 1; j <= n; ++j)
            in >> p[j][i];
    in.close();
    for(size_t i = 1; i <= n; ++i)
        for(size_t j = 0; j <= m; ++j)
            for(size_t cur = 0; cur <= j; ++cur)
            {
                cur_variant = dp[i-1][j-cur].first + p[i][cur];
                if(dp[i][j].first < cur_variant)
                {
                    dp[i][j].first = cur_variant;
                    dp[i][j].second = cur;
                }
            }
    ofstream out("profit.out");
    out << dp[n][m].first << endl;
    ans.push_back(dp[n][m].second);
    for(size_t i = n-1; i != 0; --i)
    {
        m -= ans.back();
        ans.push_back(dp[i][m].second);
    }
    for(size_t i = n-1; i != 0; --i)
        out << ans[i] << ' ';
    out << ans[0] << endl;
    out.close();
    return 0;
}
